varying vec3 P;
varying vec3 N;
uniform sampler2D sampler0;	//TEXTURE0
uniform sampler2D sampler1;	//TEXTURE1
uniform float mixFactor;	//

uniform int textureFlag;	//1:eNX` 0:eNX`Ȃ
vec4 texColor, texColor2;

void main (void)
{
		if(textureFlag == 1)	//IuWFNgɃeNX`镔̏ꍇ
		{
			//eNX`̐F߂
	        vec4 color0 = texture2D(sampler0, gl_TexCoord[0].st);
	        vec4 color1 = texture2D(sampler1, gl_TexCoord[1].st);
	        
	        float white = (color1.r + color1.g + color1.b) / 3.0;
	        
	        if(white >= 0.99)		//gD[peNX`̐Fꍇ
	        {		
	        	texColor = color0;
	        }	
	        else if(white <= 0.01)	//gD[peNX`̐Fꍇ
	        {
	        	texColor = color1;
	        }
	        else
	        {
	        	texColor = mix(color0, color1, 0.5);
	        }

			gl_FragColor = texColor;
		}
		else	//IuWFNgɃeNX`̏ꍇ
		{
			vec3 L = normalize(gl_LightSource[0].position.xyz - P);
			vec4 ambient = gl_FrontLightProduct[0].ambient;
			float dotNL = dot(N, L);
			vec4 diffuse = gl_FrontLightProduct[0].diffuse * max(0.0, dotNL);
			vec3 V = normalize(-P);
			vec3 H = normalize(L + V);
			float powNH = pow(max(dot(N, H), 0.0), gl_FrontMaterial.shininess);

			if(dotNL <= 0.0) powNH = 0.0;
			vec4 specular = gl_FrontLightProduct[0].specular * powNH;
	        
			//GL_MODULATE[h
			gl_FragColor = ambient + diffuse + specular;;
			
			//Cӂ̍w肷ꍇ͂B1.0ɂGL_REPLACEƓƂɂȂ
			//gl_FragColor = mix(ambient + diffuse, texColor, 0.7) + specular;
		}
}